#include "common.h"

HWND a_hwnd[ 4 ] = { 0 };

void drawText( HDC hdc, LPCTSTR psz, LPRECT prc, UINT flags ) {
    HFONT hfont = CreateFont( 72, 0, 0, 0, FW_BOLD, 0, 0, 0,
        ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
        PROOF_QUALITY, VARIABLE_PITCH | FF_SWISS, _T( "Arial" ) );
    HFONT hfontSaved = SelectFont( hdc, hfont );
    DrawText( hdc, psz, -1, prc, flags );
    SelectFont( hdc, hfontSaved );
    DeleteFont( hfont );
}

void windowSizeFromText( LPCTSTR psz, SIZE *pSize ) {
    HDC  hdc = GetDC( 0 );
    RECT rc  = { 0 };
    drawText( hdc, psz, &rc, DT_CALCRECT | DT_CENTER );
    pSize->cx = rc.right  - rc.left + 2 * BORDER;
    pSize->cy = rc.bottom - rc.top  + 2 * BORDER;
    ReleaseDC( 0, hdc );
}

void onChar( HWND hwnd, TCHAR ch, int cRepeat ) {
    int iWindow;
    for ( iWindow = 0; iWindow < 4; ++iWindow ) {
        DestroyWindow( a_hwnd[ iWindow ] );
    }
    PostQuitMessage( 0 );
}

UINT onNCHitTest( HWND hwnd, int x, int y ) {
    return HTCAPTION;
}

/* end of file */
