#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include "resource.h"
#include "hclib.h"
#include "defblib.h"

#define dim( X ) (sizeof( X ) / sizeof( (X)[ 0 ] ))

int getComboTextLength( HWND hwndCtl, int codeNotify ) {
    const int nSelection = ComboBox_GetCurSel( hwndCtl );
    if ( CBN_SELCHANGE == codeNotify && 0 <= nSelection ) {
        return ComboBox_GetLBTextLen( hwndCtl, nSelection );
    }
    return ComboBox_GetTextLength( hwndCtl );
}

BOOL CALLBACK
dlgHist( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam ) {
    const int  id         = GET_WM_COMMAND_ID  ( wParam, lParam );
    const int  codeNotify = GET_WM_COMMAND_CMD ( wParam, lParam );
    const HWND hwndCombo  = GetDlgItem( hwnd, IDC_COMMAND );

    static HIST_DESCR histDescr = {
        FALSE, 10, _T( "WDJ\\HistDemo\\Command History" ),
        _T( "Command" ),
    };

    switch ( msg ) {
    case WM_INITDIALOG:
        Static_SetIcon( GetDlgItem( hwnd, IDC_PICTURE ),
            LoadIcon( 0, IDI_WINLOGO ) );
        ComboBox_LimitText( hwndCombo, MAX_PATH );
        histInit( hwndCombo, &histDescr );
        EnableWindow( GetDlgItem( hwnd, IDOK ), FALSE );
        return TRUE; //*** FUNCTION EXIT POINT

    case WM_DESTROY:
        //histExit( hwndCombo ); // Not necessary.
        break;

    case WM_COMMAND:
        if ( BN_CLICKED == codeNotify ) {
            if ( IDOK == id ) {
                TCHAR szCmd[ MAX_PATH       ] = { 0 };
                TCHAR szMsg[ MAX_PATH + 100 ] = { 0 };
                histUpdate( hwndCombo );
                ComboBox_GetText( hwndCombo, szCmd, dim( szCmd ) );
                wsprintf( szMsg, _T( "Last 'command': %s"), szCmd );
                SetDlgItemText( hwnd, IDC_PREV, szMsg );
            } else if ( IDCANCEL == id ) {;
                EndDialog( hwnd, IDCANCEL );
            } else if ( IDC_CASESENSITIVE == id ) {
                histDescr._isCaseSensitive =
                    IsDlgButtonChecked( hwnd, IDC_CASESENSITIVE );
            }
        } else if ( IDC_COMMAND == id ) {
            const int nLen =
                getComboTextLength( hwndCombo, codeNotify );
            EnableWindow( GetDlgItem( hwnd, IDOK ), 0 < nLen );
        }
        return TRUE; //*** FUNCTION EXIT POINT
    }
    return FALSE;
}

int APIENTRY
_tWinMain( HINSTANCE hinst, HINSTANCE h2, LPSTR psz, int nShow ) {
    fixDefBtns();
    DialogBox( hinst, _T( "TestDlg" ), HWND_DESKTOP, dlgHist );
    return 0;
}
